' socket.bas
' Copyright 1999 by Richard Dawe
'
' This is distributed under the terms of the GNU Library General Public
' License. Please see the file lgpl.txt that came with this file.
'
' Socket test program

REM $INCLUDE: 'wsockvxd.bi'

CONST AFINET& = 1

CONST SOCKSTREAM& = 1
CONST SOCKDGRAM& = 2

CONST IPPROTOTCP& = 6
CONST IPPROTOUDP& = 17

TYPE SOCKETCREATE
    AddressFamily   AS LONG
    SocketType      AS LONG
    Protocol        AS LONG
    NewSocket       AS LONG
    NewSocketHandle AS LONG
END TYPE

TYPE SOCKETCLOSE
    socket          AS LONG
END TYPE

DECLARE SUB QBWSOCK CDECL (retval AS INTEGER, command AS INTEGER, params AS ANY)
DECLARE FUNCTION CREATESOCKET& (AddressFamily AS LONG, SocketType AS LONG, Protocol AS LONG)
DECLARE FUNCTION CLOSESOCKET& (socket AS LONG)

DIM socket AS LONG

PRINT "Testing qbwsock..."

i% = 0
CALL QBWSOCK(i%, 0, psock)
PRINT i%

socket& = CREATESOCKET&(AFINET&, SOCKSTREAM&, IPPROTOTCP&)
PRINT socket&
'PRINT CLOSESOCKET&(socket&)

i% = 0
CALL QBWSOCK(i%, 1, psock)
PRINT i%

FUNCTION CLOSESOCKET& (socket AS LONG)
    DIM params AS SOCKETCLOSE
    DIM retval AS INTEGER

    params.socket = socket

    CALL QBWSOCK(retval, SOCKETCLOSECMD%, params)

    CLOSESOCKET& = retval
END FUNCTION

FUNCTION CREATESOCKET& (AddressFamily AS LONG, SocketType AS LONG, Protocol AS LONG)
    DIM params AS SOCKETCREATE
    DIM retval AS INTEGER

    params.AddressFamily = AddressFamily
    params.SocketType = SocketType
    params.Protocol = Protocol
    params.NewSocket = 0
    params.NewSocketHandle = INT((&HFFF + 1) * RND) + &H40000000

    CALL QBWSOCK(retval, SOCKETCMDCREATE%, params)

    IF (retval% <> -1) THEN
        CREATESOCKET& = params.NewSocket
    ELSE
        CREATESOCKET& = retval%
    END IF
END FUNCTION

